package fr.gaellalire.vestige.admin.ssh;

/*
 * This file is part of Vestige.
 *
 * Vestige is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Vestige is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Vestige.  If not, see <http://www.gnu.org/licenses/>.
 */

import org.apache.sshd.common.NamedFactory;
import org.apache.sshd.common.Signature;
import org.apache.sshd.common.signature.AbstractSignature;

public class SignatureRSASHA512 extends AbstractSignature {

    /**
     * A named factory for RSA <code>Signature</code>
     */
    public static class Factory implements NamedFactory<Signature> {

        public String getName() {
            return "rsa-sha2-512";
        }

        public Signature create() {
            return new SignatureRSASHA512();
        }

    }

    public SignatureRSASHA512() {
        super("SHA512withRSA");
    }

    public byte[] sign() throws Exception {
        return signature.sign();
    }

    public boolean verify(byte[] sig) throws Exception {
        sig = extractSig(sig);
        return signature.verify(sig);
    }

}
